/*
 * KernelConf - A Linux Kernel Configuration System
 *
 * Distributed under GNU General Public Lisence
 *
 * Copyright (C) 2002 by Anuradha Ratnaweera
 */

#ifndef _KCONF_EXPRESSIONS_H
#define _KCONF_EXPRESSIONS_H

#include "tree.h"
#include "values.h"

/* Precedence is not NULL only for operators */
typedef enum {
    PRE_NULL,
    PRE_ASSIGN,
    PRE_OR,
    PRE_AND,
    PRE_EQUAL,
    PRE_REL,
    PRE_NOT
} Precedence;

typedef struct _Token* TokenPtr;

typedef struct _Token {
    Type type;
    Precedence precedence;
    Value value;
    TokenPtr next;
} Token;

typedef struct _Expression* ExpressionPtr;

typedef struct _Expression {
    TokenPtr first_token;
    ExpressionPtr next;
} Expression;

ExpressionPtr parse_expressions(char*, NodePtr, int);
void add_expressions_to_list(ExpressionPtr*, ExpressionPtr);
TokenPtr evaluate_expression(ExpressionPtr, NodePtr);
int evaluate_expressions_yn(ExpressionPtr, NodePtr);

#endif /* _KCONF_EXPRESSIONS_H */
