/*
 * KernelConf - A Linux Kernel Configuration System
 *
 * Distributed under GNU General Public Lisence
 *
 * Copyright (C) 2002 by Anuradha Ratnaweera
 */

#include <string.h>

#include "menuconfig.h"
#include "oldconfig.h"
#include "readsymbols.h"
#include "ttyconfig.h"
#include "xconfig.h"

int main(int argc, char *argv[])
{
    int retval = 0;

    if ((retval = read_symbols(argv[1])))
	return retval;

    if (strcmp(argv[2], "ttyconfig") == 0)
	retval = do_ttyconfig();
    else if (strcmp(argv[2], "menuconfig") == 0)
	retval = do_menuconfig();
    else if (strcmp(argv[2], "xconfig") == 0)
	retval = do_xconfig();
    else if (strcmp(argv[2], "oldconfig") == 0)
	retval = do_oldconfig();
    else {
	if (do_xconfig())
	    if (do_menuconfig())
		retval = do_ttyconfig();
    }

    return retval;
}
